# Copyright (c) 2023 Daniel Dohr, Josef Wachtler
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


# Da die Klassen recht klein sind, ist es übersichtlicher sie in einer Datei zusammenzufassen.
# Die einfache Version der Bus Klasse.
class Bus:
    typ = "undefined"
    driver = "undefined"
    number_of_seats = 0

    def __init__(self, typ, number_of_seats, driver):
        self.typ = typ
        self.number_of_seats = number_of_seats
        self.driver = driver

    # Ausgabe der Attribute
    def printData(self):
        print("\t\tName: {}\t Bustyp: {}\t Anzahl der Sitze: {}".format(self.driver, self.typ, self.number_of_seats))


# Klasse mit public Attributen
class BusTypA:
    typ = "17b"
    number_of_seats = 41
    driver = "undefined"

    def __init__(self, driver):
        self.driver = driver

    def printData(self):
        print("\t\tName: {}\t Bustyp: {}\t Anzahl der Sitze: {}".format(self.driver, self.typ, self.number_of_seats))


# Klasse mit einem Konstruktor der einen optionalen Parameter enthält
class BusTypB:
    typ = "17b"
    number_of_seats = 41
    driver = "undefined"

    def __init__(self, typ, driver="Fahrer1"):
        self.driver = driver
        self.typ = typ

    def printData(self):
        print("\t\tName: {}\t Bustyp: {}\t Anzahl der Sitze: {}".format(self.driver, self.typ, self.number_of_seats))

