# Copyright (c) 2023 Daniel Dohr, Josef Wachtler
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


# Import Statements um die Inhalte der anderen Dateien hier zugänglich zu machen.
import sys
import os
sys.path.append(os.path.abspath(os.path.dirname(__file__)))
from Buses import Bus, BusTypA, BusTypB
from Dog import Dog


# Diese Methode wird in main.py ausgeführt und soll die Ergebnisse in einer leserlichen Form ausgeben.
def run_lecture_two():
    print("\n*** Lecture 2 Start ***")
    print(" --Ausgabe der Bus Beispiele-- \n")

    text_wrapper("Erstes Beispiel", first_bus_example)
    text_wrapper("Zweites Beispiel", second_bus_example)
    text_wrapper("Drittes Beispiel", third_bus_example)

    print(" --Ausgabe des Dog Beispiels-- \n")
    text_wrapper("Dog Beispiel", dog_example)
    print("*** Lecture 2 End ***")


# Um eine gleichmässige Ausgabe zu gewährleisten und Code zu sparen haben wir hier eine kleine Hilfsfunktion
def text_wrapper(title, example):
    print(f"\t - {title} -")
    example()
    print("\n")


# Das erste Bus-Beispiel das mit der Klasse Bus arbeitet
def first_bus_example():
    bus1 = Bus("3a", 38, "John A.")
    bus2 = Bus("17b", 42, "Klaus M.")

    bus1.printData()
    bus2.printData()


# Das zweite Bus-Beispiel, bei dem wir sehen, dass wir Attribute verändern können
def second_bus_example():
    bus1 = BusTypA("John A.")
    bus2 = BusTypA("Klaus M.")

    bus1.typ = "3a"

    bus1.printData()
    bus2.printData()


# Das dritte Bus-Beispiel das die Verwendung von optionalen Parametern zeigt
def third_bus_example():
    bus1 = BusTypB("3a")
    bus2 = BusTypB("2a", "Klaus M.")

    bus1.printData()
    bus2.printData()


# Dieses Beispiel zeigt das von außen auch auf private Attribute zugegriffen werden kann
def dog_example():
    bello = Dog("Bello")

    bello.printData()
    bello.__private_variable = "\tAuf der Suche nach Bello"

    bello.printData()

    bello._Dog__private_variable = "Bello wurde gefunden"
    bello.printData()

