# Copyright (c) 2023 Daniel Dohr, Josef Wachtler
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


# Diese Klasse enthält alle Methodenversionen.
class DecoratedDog:
    name = "undefined"
    species = "Canis"

    def __init__(self, name):
        self.name = name

    # Beispiel einer Instanz Methode
    def bark_in_language(self, language):
        match language:
            case "french":
                print("\t\t{}: wau, wau".format(self.name))
            case "englisch":
                print("\t\t{}: woof, woof".format(self.name))
            case _:
                print("\t\t{}: barf, barf".format(self.name))

    # @ signalisiert die Verwendung eines Decorators.
    @classmethod
    def print_species(cls):
        print(("\t\t{}'s spezies ist: " + cls.species).format(cls.name))

    @staticmethod
    def bark():
        print("\t\tWoof, woof")
