# Copyright (c) 2023 Daniel Dohr, Josef Wachtler
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


# Das ist unser selbst erstellter Decorator. Eine Funktion wird als Parameter übergeben
def our_decorator(function_we_want_to_modify):
    # In ihm wird eine weitere Funktion definiert die, die übergebene Funktion umschließt
    def wrapper():
        print("\t\tDie Funktion wird um diese Ausgabe erweitert: 1/2")
        function_we_want_to_modify()
        print("\t\tDie Funktion wird um diese Ausgabe erweitert: 2/2 \n")
    return wrapper


# wir können mit @ einer Funktion einen Decorator zuweisen.
@our_decorator
def decorated_function():
    print("\t\tMeine Dekoration wird über das @-Zeichen bestimmt.")


# Oder wir definieren wie sonst auch unsere Funktion und rufen die Decorator Funktion auf.
def unsuspecting_function():
    print("\t\tMeine Dekoration wird direkt zugewiesen.")


# Das Resultat ist dasselbe
def decorator_example():
    function_handle = our_decorator(unsuspecting_function)
    function_handle()
    decorated_function()

