# Copyright (c) 2023 Daniel Dohr, Josef Wachtler
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


# Import Statements um die Inhalte der anderen Dateien hier zugänglich zu machen.
import sys
import os
sys.path.append(os.path.abspath(os.path.dirname(__file__)))
from BasicDog import BasicDog
from DecoratedDog import DecoratedDog
from Calculator import Calculator
from DecoratorExample import decorator_example


# Diese Methode wird in main.py ausgeführt und soll die Ergebnisse in einer leserlichen Form ausgeben.
def run_lecture_three():
    print("\n*** Lecture 3 Start ***")
    print(" --Verwendung der verschiedenen Methodenarten-- \n")

    text_wrapper("Einfacher Zugriff auf ein Objektattribut", basic_attribute_output_example)
    text_wrapper("Aufruf einer Instanz Methode", instance_method_example)
    text_wrapper("Verwendung einer Klassenmethode", class_method_example)
    text_wrapper("Verwendung einer statischen Methode", static_method_example)

    print(" --Ausgabe des Decorator Beispiels-- \n")
    text_wrapper("Decorator Beispiel", decorator_example)
    print("*** Lecture 3 End ***")


# Um eine gleichmässige Ausgabe zu gewährleisten und Code zu sparen haben wir hier eine kleine Hilfsfunktion
def text_wrapper(title, example):
    print(f"\t - {title} -")
    example()
    print("\n")


# Das erste Dog Beispiel
def basic_attribute_output_example():
    dog1 = BasicDog("Zeus", 3)
    print("\t\t Output: {}".format(dog1.get_name()))


# Beispiel einer einfachen Instanz Methode
def instance_method_example():
    dog1 = DecoratedDog("Bello")
    dog1.bark_in_language("french")
    DecoratedDog.bark()


# Beispiel einer Klassenmethode
def class_method_example():
    dog1 = DecoratedDog("Bello")

    DecoratedDog.print_species()  # Print über Klasse
    dog1.print_species()  # Print über Referenz

    dog1.species = "Katze"
    print("\t\t{}".format(dog1.species))
    dog1.print_species()


# Beispiel einer statischen Methode
def static_method_example():
    calc = Calculator()
    print("\t\t{}".format(Calculator.addNumbers({2, 4, 6})))
    print("\t\t{}".format(calc.addNumbers({2, 4, 6})))


