# Copyright (c) 2023 Daniel Dohr, Josef Wachtler
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


# Import Statements um die Inhalte der anderen Dateien hier zugänglich zu machen.
import sys
import os
sys.path.append(os.path.abspath(os.path.dirname(__file__)))
from Duck import Duck
from InheritanceDog import InheritanceDog
from Beaver import Beaver
from Platypus import Platypus


# Diese Methode wird in main.py ausgeführt und soll die Ergebnisse in einer leserlichen Form ausgeben.
def run_lecture_four():
    print("\n*** Lecture 4 Start ***")
    print(" --Verwendung von einfacher Vererbung-- \n")
    text_wrapper("Ausgabe des Vererbungs-Beispiels", basic_inheritance_example)

    print(" --Verwendung von mehrfach Vererbung-- \n")
    text_wrapper("Ausgabe des Mehrfachvererbungs-Beispiels", multi_inheritance_example)

    print("*** Lecture 4 End ***")


# Um eine gleichmässige Ausgabe zu gewährleisten und Code zu sparen haben wir hier eine kleine Hilfsfunktion
def text_wrapper(title, example):
    print(f"\t - {title} -")
    example()
    print("\n")


# Das erste Vererbungsbeispiel. Wir sehen, dass die Methoden aus der Animal Klasse verwendet werden können.
def basic_inheritance_example():
    hund1 = InheritanceDog("Zeus", 2)
    hund1.say_hello()
    ente1 = Duck("Friedolin", 4)
    ente1.eat()
    ente1.say_hello()
    bieber = Beaver("Günther", 3)
    bieber.say_hello()


# Unser Schnabeltier kann Methoden aus der Duck und Beaver Klasse verwenden.
def multi_inheritance_example():
    schnabel = Platypus("Hercules", 2)
    schnabel.swim()
    schnabel.knock()
    schnabel.say_hello()

